﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace ContextMenuWPF
{
    public class ContextMenuBehavior
    {


        public static ICommand GetContextMenuOpenedCommand(DependencyObject obj)
        {
            return (ICommand)obj.GetValue(ContextMenuOpenedCommandProperty);
        }

        public static void SetContextMenuOpenedCommand(DependencyObject obj, ICommand value)
        {
            obj.SetValue(ContextMenuOpenedCommandProperty, value);
        }

        // Using a DependencyProperty as the backing store for ContextMenuOpenedCommand.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ContextMenuOpenedCommandProperty =
            DependencyProperty.RegisterAttached("ContextMenuOpenedCommand", typeof(ICommand), typeof(ContextMenuBehavior), new PropertyMetadata(ContextMenuCommandChanged));

        private static void ContextMenuCommandChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            var menu = d as RadContextMenu;
            menu.Opened += menu_Opened;
        }

        static void menu_Opened(object sender, RoutedEventArgs e)
        {
            var command = GetContextMenuOpenedCommand(sender as FrameworkElement);

            if (command != null)
            {
                command.Execute(e);
            }
        }
    }
}
